/*
    ⚠️ AUTOMATICALLY GENERATED CODE
 
    Generated by Sources/Generator/main.swift.
    Do not edit this file directly.
 
    Last generated: 2016-08-25 20:09:29 +0000
*/
import Routing
import HTTP
import HTTPRouting
import WebSockets
 
extension Routing.RouteBuilder where Value == HTTP.Responder {
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /<path>/ 
    */
    public func socket(_ p0: String = "", handler: @escaping (Request, WebSocket) throws -> ()) {
        self.add(.get, p0) { request in
            return try request.upgradeToWebSocket { try handler(request, $0) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /<path>/ 
    */
    public func get(_ p0: String = "", handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.get, p0) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /<path>/ 
    */
    public func post(_ p0: String = "", handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.post, p0) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /<path>/ 
    */
    public func put(_ p0: String = "", handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.put, p0) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /<path>/ 
    */
    public func patch(_ p0: String = "", handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.patch, p0) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /<path>/ 
    */
    public func delete(_ p0: String = "", handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.delete, p0) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /<path>/ 
    */
    public func options(_ p0: String = "", handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.options, p0) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/ 
    */
    public func socket<W0: StringInitializable>(_ w0: W0.Type, handler: @escaping (Request, WebSocket, W0) throws -> ()) {
        self.add(.get, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try request.upgradeToWebSocket { try handler(request, $0,cw0) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/ 
    */
    public func get<W0: StringInitializable>(_ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.get, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /{wildcard}/ 
    */
    public func post<W0: StringInitializable>(_ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.post, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /{wildcard}/ 
    */
    public func put<W0: StringInitializable>(_ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.put, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /{wildcard}/ 
    */
    public func patch<W0: StringInitializable>(_ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.patch, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /{wildcard}/ 
    */
    public func delete<W0: StringInitializable>(_ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.delete, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /{wildcard}/ 
    */
    public func options<W0: StringInitializable>(_ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.options, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /<path>/<path>/ 
    */
    public func socket(_ p0: String, _ p1: String, handler: @escaping (Request, WebSocket) throws -> ()) {
        self.add(.get, p0, p1) { request in
            return try request.upgradeToWebSocket { try handler(request, $0) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /<path>/<path>/ 
    */
    public func get(_ p0: String, _ p1: String, handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.get, p0, p1) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /<path>/<path>/ 
    */
    public func post(_ p0: String, _ p1: String, handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.post, p0, p1) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /<path>/<path>/ 
    */
    public func put(_ p0: String, _ p1: String, handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.put, p0, p1) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /<path>/<path>/ 
    */
    public func patch(_ p0: String, _ p1: String, handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.patch, p0, p1) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /<path>/<path>/ 
    */
    public func delete(_ p0: String, _ p1: String, handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.delete, p0, p1) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /<path>/<path>/ 
    */
    public func options(_ p0: String, _ p1: String, handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.options, p0, p1) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /<path>/{wildcard}/ 
    */
    public func socket<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, handler: @escaping (Request, WebSocket, W0) throws -> ()) {
        self.add(.get, p0, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try request.upgradeToWebSocket { try handler(request, $0,cw0) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /<path>/{wildcard}/ 
    */
    public func get<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.get, p0, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /<path>/{wildcard}/ 
    */
    public func post<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.post, p0, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /<path>/{wildcard}/ 
    */
    public func put<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.put, p0, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /<path>/{wildcard}/ 
    */
    public func patch<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.patch, p0, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /<path>/{wildcard}/ 
    */
    public func delete<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.delete, p0, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /<path>/{wildcard}/ 
    */
    public func options<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.options, p0, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/<path>/ 
    */
    public func socket<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, handler: @escaping (Request, WebSocket, W0) throws -> ()) {
        self.add(.get, ":w0", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try request.upgradeToWebSocket { try handler(request, $0,cw0) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/<path>/ 
    */
    public func get<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.get, ":w0", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /{wildcard}/<path>/ 
    */
    public func post<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.post, ":w0", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /{wildcard}/<path>/ 
    */
    public func put<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.put, ":w0", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /{wildcard}/<path>/ 
    */
    public func patch<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.patch, ":w0", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /{wildcard}/<path>/ 
    */
    public func delete<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.delete, ":w0", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /{wildcard}/<path>/ 
    */
    public func options<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.options, ":w0", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/{wildcard}/ 
    */
    public func socket<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, WebSocket, W0, W1) throws -> ()) {
        self.add(.get, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try request.upgradeToWebSocket { try handler(request, $0,cw0, cw1) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/{wildcard}/ 
    */
    public func get<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.get, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /{wildcard}/{wildcard}/ 
    */
    public func post<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.post, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /{wildcard}/{wildcard}/ 
    */
    public func put<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.put, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /{wildcard}/{wildcard}/ 
    */
    public func patch<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.patch, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /{wildcard}/{wildcard}/ 
    */
    public func delete<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.delete, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /{wildcard}/{wildcard}/ 
    */
    public func options<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.options, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /<path>/<path>/<path>/ 
    */
    public func socket(_ p0: String, _ p1: String, _ p2: String, handler: @escaping (Request, WebSocket) throws -> ()) {
        self.add(.get, p0, p1, p2) { request in
            return try request.upgradeToWebSocket { try handler(request, $0) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /<path>/<path>/<path>/ 
    */
    public func get(_ p0: String, _ p1: String, _ p2: String, handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.get, p0, p1, p2) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /<path>/<path>/<path>/ 
    */
    public func post(_ p0: String, _ p1: String, _ p2: String, handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.post, p0, p1, p2) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /<path>/<path>/<path>/ 
    */
    public func put(_ p0: String, _ p1: String, _ p2: String, handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.put, p0, p1, p2) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /<path>/<path>/<path>/ 
    */
    public func patch(_ p0: String, _ p1: String, _ p2: String, handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.patch, p0, p1, p2) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /<path>/<path>/<path>/ 
    */
    public func delete(_ p0: String, _ p1: String, _ p2: String, handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.delete, p0, p1, p2) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /<path>/<path>/<path>/ 
    */
    public func options(_ p0: String, _ p1: String, _ p2: String, handler: @escaping (Request) throws -> ResponseRepresentable) {
        self.add(.options, p0, p1, p2) { request in
            return try handler(request).makeResponse()
        }
    }
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /<path>/<path>/{wildcard}/ 
    */
    public func socket<W0: StringInitializable>(_ p0: String, _ p1: String, _ w0: W0.Type, handler: @escaping (Request, WebSocket, W0) throws -> ()) {
        self.add(.get, p0, p1, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try request.upgradeToWebSocket { try handler(request, $0,cw0) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /<path>/<path>/{wildcard}/ 
    */
    public func get<W0: StringInitializable>(_ p0: String, _ p1: String, _ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.get, p0, p1, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /<path>/<path>/{wildcard}/ 
    */
    public func post<W0: StringInitializable>(_ p0: String, _ p1: String, _ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.post, p0, p1, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /<path>/<path>/{wildcard}/ 
    */
    public func put<W0: StringInitializable>(_ p0: String, _ p1: String, _ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.put, p0, p1, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /<path>/<path>/{wildcard}/ 
    */
    public func patch<W0: StringInitializable>(_ p0: String, _ p1: String, _ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.patch, p0, p1, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /<path>/<path>/{wildcard}/ 
    */
    public func delete<W0: StringInitializable>(_ p0: String, _ p1: String, _ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.delete, p0, p1, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /<path>/<path>/{wildcard}/ 
    */
    public func options<W0: StringInitializable>(_ p0: String, _ p1: String, _ w0: W0.Type, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.options, p0, p1, ":w0") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /<path>/{wildcard}/<path>/ 
    */
    public func socket<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, _ p1: String, handler: @escaping (Request, WebSocket, W0) throws -> ()) {
        self.add(.get, p0, ":w0", p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try request.upgradeToWebSocket { try handler(request, $0,cw0) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /<path>/{wildcard}/<path>/ 
    */
    public func get<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, _ p1: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.get, p0, ":w0", p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /<path>/{wildcard}/<path>/ 
    */
    public func post<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, _ p1: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.post, p0, ":w0", p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /<path>/{wildcard}/<path>/ 
    */
    public func put<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, _ p1: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.put, p0, ":w0", p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /<path>/{wildcard}/<path>/ 
    */
    public func patch<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, _ p1: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.patch, p0, ":w0", p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /<path>/{wildcard}/<path>/ 
    */
    public func delete<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, _ p1: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.delete, p0, ":w0", p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /<path>/{wildcard}/<path>/ 
    */
    public func options<W0: StringInitializable>(_ p0: String, _ w0: W0.Type, _ p1: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.options, p0, ":w0", p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /<path>/{wildcard}/{wildcard}/ 
    */
    public func socket<W0: StringInitializable, W1: StringInitializable>(_ p0: String, _ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, WebSocket, W0, W1) throws -> ()) {
        self.add(.get, p0, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try request.upgradeToWebSocket { try handler(request, $0,cw0, cw1) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /<path>/{wildcard}/{wildcard}/ 
    */
    public func get<W0: StringInitializable, W1: StringInitializable>(_ p0: String, _ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.get, p0, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /<path>/{wildcard}/{wildcard}/ 
    */
    public func post<W0: StringInitializable, W1: StringInitializable>(_ p0: String, _ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.post, p0, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /<path>/{wildcard}/{wildcard}/ 
    */
    public func put<W0: StringInitializable, W1: StringInitializable>(_ p0: String, _ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.put, p0, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /<path>/{wildcard}/{wildcard}/ 
    */
    public func patch<W0: StringInitializable, W1: StringInitializable>(_ p0: String, _ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.patch, p0, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /<path>/{wildcard}/{wildcard}/ 
    */
    public func delete<W0: StringInitializable, W1: StringInitializable>(_ p0: String, _ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.delete, p0, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /<path>/{wildcard}/{wildcard}/ 
    */
    public func options<W0: StringInitializable, W1: StringInitializable>(_ p0: String, _ w0: W0.Type, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.options, p0, ":w0", ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/<path>/<path>/ 
    */
    public func socket<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, _ p1: String, handler: @escaping (Request, WebSocket, W0) throws -> ()) {
        self.add(.get, ":w0", p0, p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try request.upgradeToWebSocket { try handler(request, $0,cw0) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/<path>/<path>/ 
    */
    public func get<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, _ p1: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.get, ":w0", p0, p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /{wildcard}/<path>/<path>/ 
    */
    public func post<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, _ p1: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.post, ":w0", p0, p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /{wildcard}/<path>/<path>/ 
    */
    public func put<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, _ p1: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.put, ":w0", p0, p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /{wildcard}/<path>/<path>/ 
    */
    public func patch<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, _ p1: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.patch, ":w0", p0, p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /{wildcard}/<path>/<path>/ 
    */
    public func delete<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, _ p1: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.delete, ":w0", p0, p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /{wildcard}/<path>/<path>/ 
    */
    public func options<W0: StringInitializable>(_ w0: W0.Type, _ p0: String, _ p1: String, handler: @escaping (Request, W0) throws -> ResponseRepresentable) {
        self.add(.options, ":w0", p0, p1) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            return try handler(request,cw0).makeResponse()
        }
    }
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/<path>/{wildcard}/ 
    */
    public func socket<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ p0: String, _ w1: W1.Type, handler: @escaping (Request, WebSocket, W0, W1) throws -> ()) {
        self.add(.get, ":w0", p0, ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try request.upgradeToWebSocket { try handler(request, $0,cw0, cw1) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/<path>/{wildcard}/ 
    */
    public func get<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ p0: String, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.get, ":w0", p0, ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /{wildcard}/<path>/{wildcard}/ 
    */
    public func post<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ p0: String, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.post, ":w0", p0, ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /{wildcard}/<path>/{wildcard}/ 
    */
    public func put<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ p0: String, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.put, ":w0", p0, ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /{wildcard}/<path>/{wildcard}/ 
    */
    public func patch<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ p0: String, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.patch, ":w0", p0, ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /{wildcard}/<path>/{wildcard}/ 
    */
    public func delete<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ p0: String, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.delete, ":w0", p0, ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /{wildcard}/<path>/{wildcard}/ 
    */
    public func options<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ p0: String, _ w1: W1.Type, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.options, ":w0", p0, ":w1") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/{wildcard}/<path>/ 
    */
    public func socket<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ p0: String, handler: @escaping (Request, WebSocket, W0, W1) throws -> ()) {
        self.add(.get, ":w0", ":w1", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try request.upgradeToWebSocket { try handler(request, $0,cw0, cw1) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/{wildcard}/<path>/ 
    */
    public func get<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ p0: String, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.get, ":w0", ":w1", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /{wildcard}/{wildcard}/<path>/ 
    */
    public func post<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ p0: String, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.post, ":w0", ":w1", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /{wildcard}/{wildcard}/<path>/ 
    */
    public func put<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ p0: String, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.put, ":w0", ":w1", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /{wildcard}/{wildcard}/<path>/ 
    */
    public func patch<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ p0: String, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.patch, ":w0", ":w1", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /{wildcard}/{wildcard}/<path>/ 
    */
    public func delete<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ p0: String, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.delete, ":w0", ":w1", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /{wildcard}/{wildcard}/<path>/ 
    */
    public func options<W0: StringInitializable, W1: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ p0: String, handler: @escaping (Request, W0, W1) throws -> ResponseRepresentable) {
        self.add(.options, ":w0", ":w1", p0) { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            return try handler(request,cw0, cw1).makeResponse()
        }
    }
    /**
       Establishes a WebSocket connection
       at the given path. WebSocket connections
       can be accessed using the `ws://` or `wss://`
       schemes to provide two way information
       transfer between the client and the server.
     
       **Body**
       The body closure is given access to the Request
       that started the connection as well as the WebSocket.
     
           drop.socket("test") { request, ws in
     
       }
     
       **Sending Data**
     
       Data is sent to the WebSocket stream using `send(_:Data)`
     
           try ws.send("Hello, world")
     
       **Receiving Data**
     
       Data is received from the WebSocket using
       the `onText` callback.
     
       ws.onText = { ws, text in
           drop.console.output("Received \(text)")
       }
     
       **Closing**
     
       Close the Socket when you are done.
           try ws.close()
     
       **Routing**
     
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/{wildcard}/{wildcard}/ 
    */
    public func socket<W0: StringInitializable, W1: StringInitializable, W2: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ w2: W2.Type, handler: @escaping (Request, WebSocket, W0, W1, W2) throws -> ()) {
        self.add(.get, ":w0", ":w1", ":w2") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw2 = request.parameters["w2"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            let ew2 = try W2(from: vw2)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            guard let cw2 = ew2 else {
                throw TypeSafeRoutingError.invalidParameterType(W2.self)
            }
            return try request.upgradeToWebSocket { try handler(request, $0,cw0, cw1, cw2) }
        }
    }
    /**
        This route will run for any GET request
        to a path that matches:
            /{wildcard}/{wildcard}/{wildcard}/ 
    */
    public func get<W0: StringInitializable, W1: StringInitializable, W2: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ w2: W2.Type, handler: @escaping (Request, W0, W1, W2) throws -> ResponseRepresentable) {
        self.add(.get, ":w0", ":w1", ":w2") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw2 = request.parameters["w2"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            let ew2 = try W2(from: vw2)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            guard let cw2 = ew2 else {
                throw TypeSafeRoutingError.invalidParameterType(W2.self)
            }
            return try handler(request,cw0, cw1, cw2).makeResponse()
        }
    }
    /**
        This route will run for any POST request
        to a path that matches:
            /{wildcard}/{wildcard}/{wildcard}/ 
    */
    public func post<W0: StringInitializable, W1: StringInitializable, W2: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ w2: W2.Type, handler: @escaping (Request, W0, W1, W2) throws -> ResponseRepresentable) {
        self.add(.post, ":w0", ":w1", ":w2") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw2 = request.parameters["w2"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            let ew2 = try W2(from: vw2)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            guard let cw2 = ew2 else {
                throw TypeSafeRoutingError.invalidParameterType(W2.self)
            }
            return try handler(request,cw0, cw1, cw2).makeResponse()
        }
    }
    /**
        This route will run for any PUT request
        to a path that matches:
            /{wildcard}/{wildcard}/{wildcard}/ 
    */
    public func put<W0: StringInitializable, W1: StringInitializable, W2: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ w2: W2.Type, handler: @escaping (Request, W0, W1, W2) throws -> ResponseRepresentable) {
        self.add(.put, ":w0", ":w1", ":w2") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw2 = request.parameters["w2"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            let ew2 = try W2(from: vw2)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            guard let cw2 = ew2 else {
                throw TypeSafeRoutingError.invalidParameterType(W2.self)
            }
            return try handler(request,cw0, cw1, cw2).makeResponse()
        }
    }
    /**
        This route will run for any PATCH request
        to a path that matches:
            /{wildcard}/{wildcard}/{wildcard}/ 
    */
    public func patch<W0: StringInitializable, W1: StringInitializable, W2: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ w2: W2.Type, handler: @escaping (Request, W0, W1, W2) throws -> ResponseRepresentable) {
        self.add(.patch, ":w0", ":w1", ":w2") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw2 = request.parameters["w2"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            let ew2 = try W2(from: vw2)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            guard let cw2 = ew2 else {
                throw TypeSafeRoutingError.invalidParameterType(W2.self)
            }
            return try handler(request,cw0, cw1, cw2).makeResponse()
        }
    }
    /**
        This route will run for any DELETE request
        to a path that matches:
            /{wildcard}/{wildcard}/{wildcard}/ 
    */
    public func delete<W0: StringInitializable, W1: StringInitializable, W2: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ w2: W2.Type, handler: @escaping (Request, W0, W1, W2) throws -> ResponseRepresentable) {
        self.add(.delete, ":w0", ":w1", ":w2") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw2 = request.parameters["w2"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            let ew2 = try W2(from: vw2)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            guard let cw2 = ew2 else {
                throw TypeSafeRoutingError.invalidParameterType(W2.self)
            }
            return try handler(request,cw0, cw1, cw2).makeResponse()
        }
    }
    /**
        This route will run for any OPTIONS request
        to a path that matches:
            /{wildcard}/{wildcard}/{wildcard}/ 
    */
    public func options<W0: StringInitializable, W1: StringInitializable, W2: StringInitializable>(_ w0: W0.Type, _ w1: W1.Type, _ w2: W2.Type, handler: @escaping (Request, W0, W1, W2) throws -> ResponseRepresentable) {
        self.add(.options, ":w0", ":w1", ":w2") { request in
            guard let vw0 = request.parameters["w0"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw1 = request.parameters["w1"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            guard let vw2 = request.parameters["w2"]?.string else {
                throw TypeSafeRoutingError.missingParameter
            }
            let ew0 = try W0(from: vw0)
            let ew1 = try W1(from: vw1)
            let ew2 = try W2(from: vw2)
            guard let cw0 = ew0 else {
                throw TypeSafeRoutingError.invalidParameterType(W0.self)
            }
            guard let cw1 = ew1 else {
                throw TypeSafeRoutingError.invalidParameterType(W1.self)
            }
            guard let cw2 = ew2 else {
                throw TypeSafeRoutingError.invalidParameterType(W2.self)
            }
            return try handler(request,cw0, cw1, cw2).makeResponse()
        }
    }
}